#define prefetch_vector(addr) \
__asm__ __volatile__ ("prefetcht0 %0" \
                      : \
                      : \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f)))));

#if 0
#define prefetch_matrix(addr) \
__asm__ __volatile__ ("prefetchnta %0 \n\t" \
                      "prefetchnta %1" \
                      : \
                      : \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f)))), \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+128)))
#else
#define prefetch_matrix(addr) \
__asm__ __volatile__ ("prefetcht0 %0" \
                      : \
                      : \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f)))))
#endif

#define prefetch_4_V_matrix(addr) \
__asm__ __volatile__ ("prefetcht0 %0 \n\t" \
                      "prefetcht0 %1 \n\t" \
                      "prefetcht0 %2 \n\t" \
                      "prefetcht0 %3 \n\t" \
                      "prefetcht0 %4" \
                      : \
                      : \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f)))), \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+128)), \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+256)), \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+384)), \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+512))); \
__asm__ __volatile__ ("prefetcht0 %0 \n\t" \
                      "prefetcht0 %1 \n\t" \
                      "prefetcht0 %2 \n\t" \
                      "prefetcht0 %3" \
                      : \
                      : \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+640)), \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+768)), \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+896)), \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+1024)));

#define prefetch_4_V_vector(addr) \
__asm__ __volatile__ ("prefetcht0 %0 \n\t" \
                      "prefetcht0 %1 \n\t" \
                      "prefetcht0 %2" \
                      : \
                      : \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f)))), \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+128)), \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+256)));

#define prefetch_V_matrix(addr) \
__asm__ __volatile__ ("prefetcht0 %0 \n\t" \
                      "prefetcht0 %1 \n\t" \
                      "prefetcht0 %2" \
                      : \
                      : \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f)))), \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+128)), \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))+256))); 


#define prefetch_V_vector(addr) \
__asm__ __volatile__ ("prefetcht0 %0" \
                      : \
                      : \
                      "m" (*(((char*)(((unsigned long int)(addr))&~0x7f))))); 
